﻿<!--//
////////////////////////////////////////////////////////////////////////////////
//
//  Copyright © 2008 addgadget.com  All rights reserved.
//
//  http://addgadget.com/
//
////////////////////////////////////////////////////////////////////////////////
//-->
System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = onSettingsClosed;

var NetLib;
var currentInterface = 0;
var bytesReceived = 0;
var bytesSent = 0;
var lastBytesReceived = 0;
var lastBytesSent = 0;
var bytesReceivedSec = 0;
var bytesSentSec = 0;
var	bandwidth = 0;
var	description = "";
var sentHist = new Array();
var receivedHist = new Array();
var maxHist = 110;
var timeout;
var drawstyle=0;
var scaletype=0;
var scalesize=20;
var imgNTtextImage;
var txtNTtextObject;
var imgUp;
var txtUp;
var imgDown;
var txtDown;
var back = "black"; 
var vismode = 0;
var barup = 0;
var bardown = 0;
var dcsignal = 0;
var dcsecu = 0;
var dcbarc = 1;

function onLoad()
{
    debugLog("");
    debugLog("### LOAD MAIN ###");
    debugLog("GetLibrary (Main)");
    initHist();
    NetLib = GetLibrary();
    initNetLib();
    initDisplay();
    loadSettings();
    onTimer();
    setInterval("onTimer()",1000);
    ShowIP();
}

function onUnload()
{
    terminateNetLib();
    UnregisterLibrary();
    debugLog("### UNLOAD MAIN ###");
}

function onSettingsClosed()
{
    loadSettings();
}

function onTimer()
{
    updateNetVars(); 
    refreshdisplay();
    updateGraph(); 
}

function initNetLib()
{
    debugLog("initNetLib");
    var count = NetLib.Initialize();
}

function GadgetUpdate() {

	dcsignal = System.Network.Wireless.signalStrength;

	if (dcsignal == null) { dcsignal = 0 };

	dcstatus.width = dcsignal * 0.5;
	dcstatus.height = 6;

	if (dcsignal < 1) {
		dcpercent.innerText = "None Detected";
		dcnetworkid.innerText = "ID: ----";
		dcipaddress.innerText = "IP: ----";
		} else {
		dcpercent.innerText = dcsignal + "%";
		dcnetworkid.innerText = "ID: " + System.Network.Wireless.ssid;
		dcipaddress.innerText = "IP: " + System.Network.Wireless.address;
	};

	var currentSetting = System.Gadget.Settings.read("dcbarcolour");

	if (currentSetting != "") { dcbarc = currentSetting };

	if (dcbarc == 1 || dcbarc == 0 || dcbarc == null) { dcstatus.src = "barblue.png" };

	dcsecu = System.Network.Wireless.secureConnection;

	if (dcsecu == 0) {
		dcsecure.innerText = "Not Secure";
		} else {
		dcsecure.innerText = "Secure";
	};

	setTimeout("GadgetUpdate()", 400);
}

function initDisplay()
{
    txtNTtextObject = background.addTextObject("  Monitor ruchu sieci" , "Arial", 11, "silver", 8, 5); 
    imgUp = background.addImageObject("arrow_up_green.png", 8, 29);
    imgDown = background.addImageObject("arrow_down_yellow.png", 61, 29);
}

function updateNetVars()
{
    
    lastBytesReceived = bytesReceived;
    lastBytesSent = bytesSent;
      
    bytesReceived = parseInt(NetLib.BytesReceived(currentInterface));
	bytesSent = parseInt(NetLib.BytesSent(currentInterface));
	
	bytesReceivedSec = bytesReceived - lastBytesReceived;
    bytesSentSec = bytesSent - lastBytesSent;

    //bytesReceivedSec = 1026123;
    //bytesSentSec = 1026123;
    
    if (lastBytesReceived == 0)
        bytesReceivedSec = 0;
    if (lastBytesSent  == 0)
       bytesSentSec = 0;

    if (bytesReceivedSec < 0)
        bytesReceivedSec = 0;
    if (bytesSentSec < 0)
       bytesSentSec = 0;

	if (receivedHist.push(bytesReceivedSec) > maxHist)
		receivedHist.shift();
	
	if (sentHist.push(bytesSentSec) > maxHist)
		sentHist.shift();
	
	
}

function terminateNetLib()
{
    debugLog("terminateNetLib");
    try
    {
        NetLib.Terminate();
    } catch(err) {debugLog("terminate NetLib Error!")}
    NetLib = null;
}

function fourdigits(val)
{
    if (val > 1000)
        return val.toFixed(0);
    else if (val > 100)
        return val.toFixed(1);
    else if (val > 10)
        return val.toFixed(2);
    else
        return val.toFixed(3);    
}

function formatBytes(bytes)
{
    if (bytes > 1048576)
        return fourdigits((bytes / 1024) / 1024) + "M";
        
    if (bytes > 1024)
        return fourdigits(bytes / 1024) + "K";
        
    return fourdigits(bytes);    
}

function refreshdisplay()
{
    
    if (vismode != 0)
    {
        txtUpBits.innerText = formatBytes(bytesSentSec)+"B/s";
        txtDownBits.innerText = formatBytes(bytesReceivedSec)+"B/s";
    }
    else
    {
        txtUpBits.innerText = formatBytes(bytesSentSec*8)+"bit/s";
        txtDownBits.innerText = formatBytes(bytesReceivedSec*8)+"bit/s";
        txtUpBytes.innerText = formatBytes(bytesSentSec)+"B/s";
        txtDownBytes.innerText = formatBytes(bytesReceivedSec)+"B/s";
    }
}

function initHist()
{
    for (var i=0; i<maxHist; i++)
	{
	    sentHist[i]=0;
	    receivedHist[i]=0;
	}
}

function getMaxValue()
{
    var max = 0;
    for (var i=0; i<maxHist; i++)
	{
	    if (sentHist[i] > max)
	      max = sentHist[i];
	    if (receivedHist[i] > max)
	      max = receivedHist[i];
	}
	return max;
}

function updateGraph()
{
    var downpath = "m 0,30 ";
    var uppath = "m 0,30 ";
	var ub = 0;
	var db = 0;
	var param="";
	var max = 0;
	var v_max = getMaxValue();
	
	max = scalesize*1024;
	
	if  ( (v_max > max) || (scaletype == 0) )
	    max = v_max;
	else 
	    max = scalesize*1024;     
	
	try
    {
    
    
	    if (vismode != 0)
        {
	        if ( barup == 0 )
	        {
	            imgbar1.src = "bargreen.png";
	            bar1.style.width = parseInt( 50 / (max / bytesSentSec) );
	        }
	        else if ( bytesSentSec > barup )
	        {
	            imgbar1.src = "barred.png";
	            //bar1.style.width = parseInt( 50 / (max / bytesSentSec) );
	            bar1.style.width = 50;
	        }
	        else
	        {
	            imgbar1.src = "bargreen.png";
	            bar1.style.width = parseInt( 50 / (barup / bytesSentSec) );
	        }
    	    
	        if ( bardown == 0 )
	        {
	            imgbar2.src = "baryellow.png";
	            bar2.style.width = parseInt( 50 / (max / bytesReceivedSec) );
	        }
	        else if ( bytesReceivedSec > bardown )
	        {
	            imgbar2.src = "barred.png";
	            //bar2.style.width = parseInt( 50 / (max / bytesReceivedSec) );
	            bar2.style.width = 50;
	        }
	        else
	        {
	            imgbar2.src = "baryellow.png";
	            bar2.style.width = parseInt( 50 / (bardown / bytesReceivedSec) );
	        }
	    }
	        
    	
	    for (var i=0; i<maxHist; i++)
	    {
    		
		    ub = parseInt( 30 / (max / sentHist[i]) ) ;
		    db = parseInt( 30 / (max / receivedHist[i]) ); 
    		
		    if (ub > 30) ub = 30;
		    if (db > 30) db = 30;
    		
    		
		    if (drawstyle==1)
		    {
		        param =  (ub == 0) ? "m" : "l";
    	        uppath += " m " + parseInt(i+1) + ",30 " + param + " " + parseInt(i+1) + "," +parseInt(30-(ub)) + "";
        	    
    	        param =  (db == 0) ? "m" : "l";
      		    downpath += " m " + parseInt(i+1) + ",30 " + param + " " + parseInt(i+1) + "," +parseInt(30-(db)) + "";
    	    }
    	    else
    	    {
		        uppath += " l " + parseInt(i+1) + "," +parseInt(30-(ub));
		        downpath += " l " + parseInt(i+1) + "," +parseInt(30-(db));
		    }
      		
  	    }
  	}
  	catch(err) 
	{
	    debugLog("updateGraph: "+err.name+" - "+err.message)
	}
	
	uppath = uppath + " e";
	downpath = downpath + " e";
	downgraph.path = downpath;
	upgraph.path= uppath;
}

function loadSettings()
{
    debugLog("loadSettings[Main]");
    debugLog("loadSettings:Interface->"+ System.Gadget.Settings.read("interface"));
    currentInterface = System.Gadget.Settings.read("interface");
    if (currentInterface == "") currentInterface=0;     
    
    debugLog("loadSettings:DrawStyle->"+ System.Gadget.Settings.read("drawstyle"));
    drawstyle = System.Gadget.Settings.read("drawstyle");     
    
    debugLog("loadSettings:ScaleType->"+ System.Gadget.Settings.read("scaletype"));
    scaletype = System.Gadget.Settings.read("scaletype");  
    
    debugLog("loadSettings:ScaleSize->"+ System.Gadget.Settings.read("scalesize"));
    scalesize = System.Gadget.Settings.read("scalesize");   
    
    debugLog("loadSettings:VisMode->"+ System.Gadget.Settings.read("vismode"));
    vismode = System.Gadget.Settings.read("vismode");   
    
    debugLog("loadSettings:barup->"+ System.Gadget.Settings.read("barup"));
    barup = System.Gadget.Settings.read("barup") * 1024;   
    
    debugLog("loadSettings:bardown->"+ System.Gadget.Settings.read("bardown"));
    bardown = System.Gadget.Settings.read("bardown") * 1024;   
    
    var b = System.Gadget.Settings.readString("background");
	if ( b != "") back = b; else back = "black";   
	
	toggleVisMode();   
}

function toggleVisMode()
{
	background.src = back + ".png";
    
    if (vismode != 0)
    {
	    bar1.style.visibility = "visible";
	    bar2.style.visibility = "visible";
	    back1.style.visibility = "visible";
	    back2.style.visibility = "visible";
	    txtDownBytes.style.visibility = "hidden";
	    txtUpBytes.style.visibility = "hidden";
    }
    else
    {
	    bar1.style.visibility = "hidden";
	    bar2.style.visibility = "hidden";
	    back1.style.visibility = "hidden";
	    back2.style.visibility = "hidden";
	    txtDownBytes.style.visibility = "visible";
	    txtUpBytes.style.visibility = "visible";
    }
}

function ShowIP() {
getURL('http://ip-address.cc/ip.php')
retrievedData()
}

function getURL(url)  {
xmlReq = new XMLHttpRequest();
xmlReq.open("GET", url);
xmlReq.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
xmlReq.onreadystatechange = retrievedData;
xmlReq.send(null);
}

function retrievedData() {
if (xmlReq.readyState == 4 && xmlReq.status == 200)
{
var urlData = xmlReq.responseText;
var re =/\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)/;
rv = new String([urlData.match(re)])
var IP = rv.split(",");
ip.innerText = IP[0];
con.src = ("/world.png");
xmlReq.abort();
xmlReq = null;

}
else
   {
  ip.innerText = "brak połączenia" 
  con.src = ("/blank.png");
   }
}

function copyText() { 
var myVar = ip.innerText;
window.clipboardData.setData('text',myVar);
}